/*** Sensible Floor Entrance ***
 * This sketch coomunicates with the Procesing code called "SotoportegoDoor".
 * 
 * This Arduino file is part of:
 * ROUTES, a project by Maria Gabriella Astolfo, Alberto Elizondo and Marco Righetto
 *
 * IUAV University of Venice - Design&Arts Faculty
 * IxD Lab 2 - January-April 2010
 * 
 * Tutors: Philip Tabor and Gillian Crampton-Smith
 * Thanks to Tom Hulbert and Durrel Bishop
 * 
 ***/

// Declares the pin & LED

#define LED 11
#define BUTTON 3

// Variables

int val = 0;

int endTime;
int delayTime = 2000;
boolean timer = false;

int doorModes = 10;

int fadeValue;

int ledPin = 11;    // LED connected to digital pin 11


void setup (){
  
  // Set to 9600 in this code and in the Processing code
  
  Serial.begin(9600);
  pinMode (LED, OUTPUT);
  pinMode (BUTTON, INPUT);
}

void loop (){

  delay(10);
  val = digitalRead(BUTTON);

  Serial.println(val);  
  
  // Pressing the switch 
  
  if (val == HIGH){
    digitalWrite (LED, HIGH);
    if (doorModes == 10) {
      doorModes = 0;
    }
    delay (10);
  }

  else {
    digitalWrite (LED, LOW);
  }
  

  switch(doorModes) {
  case 0:
    openingDoor();
    break;

  case 1:
    swingingDoor();
    break;

  case 2:
    fadeValue = 0;
    analogWrite (ledPin, fadeValue);
    break;


  }

}

// Case 0 actions. The LED fades in and out 

void openingDoor() {
  for(fadeValue = 0 ; fadeValue <= 255; fadeValue +=2) { 
    analogWrite(ledPin, fadeValue); 
    delay(90); 
  } 
  if (fadeValue>250){
    doorModes = 1;
  }

}

// Case 1 actions. The LED is turned on for a period of time and then it goes off.

void swingingDoor(){

  timer = true;

  if (timer == true) {
    endTime = millis();
  }


  if (millis() - endTime> delayTime){
    doorModes = 2;

  }

  for(fadeValue = 250 ; fadeValue >= 30 ; fadeValue -=5) { 
    analogWrite(ledPin, fadeValue); 
    delay(30);
  }

  for(fadeValue = 30 ; fadeValue <= 255; fadeValue +=5) { 
    analogWrite(ledPin, fadeValue);
    delay(20);  
  }

}








